[Leetcode C++] Search Insert Position

Problem

Given a sorted array and a target value, return the index if the target is found. If not, return the index where it would be if it were inserted in order.

You may assume no duplicates in the array.

Here are few examples.
[1,3,5,6], 5 → 2
[1,3,5,6], 2 → 1
[1,3,5,6], 7 → 4
[1,3,5,6], 0 → 0

Analysis

We can use naive search with time O(n), or binary search with time O(log n)

Solution

Naive solution O(n)

class Solution {
public:
    int searchInsert(vector<int>& nums, int target) {
        
        for(int i =0; i<nums.size(); i++){
            if(nums[i] >= target)
                return i;
        }
        
        return nums.size();
    }
};

Binary search O(log n)

class Solution {
public:
    int searchInsert(vector<int>& nums, int target) {

        int low = 0;
        int high = nums.size()-1;
        
        //binary search
        while(low <= high){
            int mid = (low+high)/2;
            if(nums[mid] < target) low = mid+1; 
            else if(nums[mid] > target)
                high = mid-1;
            else return mid;
        }
        
        return low;
      
    }
};

Leave a Reply